package jp.ne.sakura.zautale.StoraDetector;

/**
 *  External Storage Checker
 *                  copyright: zautale (2012-10-09)
 *  
 *                                 RɂgB
 *  
 *  1.02 ... Jo[W@i2012-10-09j
 *  1.03 ... IS12S Ή@i2012-10-23j
 *  1.04 ... Lenovo@ideapad a1 ΉARgJavaDoc`Ɂ@i2012-10-24j
 *  1.05 ... ISW13HT ΉiftHgXg[W̒𑖍@\ǉj@i2012-11-01j
 *  1.06 ... }Eg|CgA}Eg|Cgꗗ̎擾p[^ύX@i2012-11-04j
 *  1.07 ... }Eg|CgpX擾̂߁Avold.fstabQƂ鏈ǉi2013-02-07j
 *  
 *  @author@zautale
 *  @version 1.07
 *  
 */

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.File;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.os.Environment;
import android.os.StatFs;

import android.util.Log;


public class ExternalStorageChecker {

	/**
	 * p[eBVi[ĂNX
	 */
	public static class FsInfo {

		/**@}Eg|Cg */
		public String mountPoint = null;
		
		/** x */
		public String labelForVolume = null;	// vold.fstabɋLqȂꍇAnull
		
		/** }EgĂ邩 */
		public boolean isMounted = false;
		
		/** t@CVXe */
		public String fileSystem = null;	// }EgĂȂnull
		
		/** Ŝ̗e<br>getBlockSize() * getBlockCount() */
		public long totalSzie = -1;

		/** 󂫗̗̈e<br>getBlockSize() * getAvailableBlocks() */
		public long availableSize = -1;		//
		
		/**
		 * RXgN^
		 */
		public FsInfo() {

		}

		public FsInfo(
				String label
		){
			setLabel( label );
		}

		
		/**
		 * t@CVXei[
		 * 
		 * @param	fsys		t@CVXe
		 */

		public void setFileSystem(
				String fsys
		){
			this.fileSystem = fsys;
		}
		
		
		/**
		 * }EgԂ̃tOZbg
		 * 
		 * @param	ism			}Eg
		 */
		public void setMountStatus(
				boolean ism
		){
			isMounted = ism;
		}

		/**
		 * p[eBV̗eʂƎcʂZbgi}EgԂfalseȂ -1 ɂȂj
		 * 
		 *@@param	blkSize		ubNTCY
		 *@@param	blkCount	g[^̃ubN
		 *@@param	avaCount	p\̈̃ubN
		 */
		public void setSize(
				int blkSize,
				int blkCount,
				int avaCount
		){
			if (isMounted) {
				totalSzie = (long)blkSize * (long)blkCount;
				availableSize = (long)blkSize * (long)avaCount;	

			} else {

				totalSzie = -1;
				availableSize = -1;	
			}
		}
		
		
		/**
		 * p[eBVɊt郉xi[
		 * 
		 * @param lfv	p[eBVɊt郉xidev_mountR}h̑j
		 */
		public void setLabel(
				String lfv
		){
			labelForVolume = lfv;
		}
		
		
		
		/**
		 * g̕
		 * 
		 * @param	mp	FsInfõ}Eg|Cg
		 * 
		 * @return		FsInfo
		 */
		protected FsInfo clone(
				String mp
		){
			FsInfo res = new FsInfo();
			
			res.mountPoint = mp;
			res.isMounted = this.isMounted;
			res.totalSzie = this.totalSzie;
			res.availableSize = this.availableSize;
			res.labelForVolume = this.labelForVolume;
			res.fileSystem = this.fileSystem;
			
			return res;
		}

	};
	
	
	

	/**
	 * ϐƁApXi[Ăꍇ̋؂蕶iK\j<br>
	 * DIɃqbgp^[ɔzu邱ƁB
	 */
	private static final String[] EnvValKeywords = {

		"^EXTERNAL_STORAGE_ALL$",				"\\s*:\\s*",	// pX񋓂^Cv
		"^SECONDARY_STORAGE$",					"\\s*:\\s*",
		"^SECOND_VOLUME_STORAGE$",				null,
		"^THIRD_VOLUME_STORAGE$",				null,
		"^INTERNAL_STORAGE\\d*$",				null,			// ͖ӓ_ orz
		"^EXTERNAL_STORAGE\\d*$",				null,
		"^EXTERNAL_[A-Z0-9]+_STORAGE\\d*$",		null,			// ԂɃfoCX̎ނȂǁiSDAUSBAALTcjp^[
		"^EXTERNAL_STORAGE_[A-Z0-9]+$",			null,			// ɃfoCX̎ނȂǁiSDAUSBcjp^[
		"^EXTERNAL_REMOVABLE_SDCARD\\d*$",		null,

	};
	
	/** vold.fstabt@C֘A */
	
	/** pX */
	private static final String pathOfFstab = "/system/etc/vold.fstab";		// ߑłĂ̂낤H
	
	/** p^[ */
	private static final String fstabMatchingPatt = "^(dev|fuse)_mount\\s+(\\S+)\\s+(\\S+)";	// @ƂĂ͂ד
	
	/** fstabt@C݂邩ǂ */
	private boolean fstabExistStatus = false;

	/** pX擾Ɋւp[^ */

	/** ׂẴpX */
	public static final int GET_ALL_STORAGE				= 0x00000000;

	/** ftHgXg[WȂ */
	public static final int OMIT_DEFAULT_STORAGE		= 0x00000001;

	/** }EgĂȂXg[WȂ */
	public static final int OMIT_UNMOUNT_STORAGE		= 0x00000002;
	
	
	
	/** }Eg|CgƂ̃p[eBV̏i[ĂRNV 
	 * 
	 * @param	<String>	}Eg|Cg̃pX
	 * @param	<FsInfo>	p[eBV̏i[FsInfo
	 * */
	private HashMap<String,FsInfo> storagePaths;		

	/** EnvironmentNX擾łftHgXg[W̃pX */
	private File defaultExternalStorage;

	/** EnvironmentNX擾łftHgXg[W̏ */
	private String defaultExternalStorageState;

	/** ftHgXg[W̒ɂ}Eg|Cg𑖍tO<br>iϐɓo^ĂȂ@Ήj */
	private boolean searchUnregisteredMountPointFlag = false;

	/**
	 * RXgN^
	 * 
	 * @param isScanUnderDefault	trueŊϐɓo^ĂȂ}Eg|Cg𒲂ׂ<br>wfalse
	 */
	public ExternalStorageChecker(
			boolean isScanUnderDefault
	){
		initialize( isScanUnderDefault );
	}
	
	public ExternalStorageChecker(){

		initialize( false );
	}

	/**
	 * RXgN^̎
	 * 
	 * @param isScanUnderDefault	trueŊϐɓo^ĂȂ}Eg|Cg𒲂ׂ
	 */
	private void initialize(
			boolean isScanUnderDefault
	){
		searchUnregisteredMountPointFlag = isScanUnderDefault;
		
		defaultExternalStorage = Environment.getExternalStorageDirectory();
		defaultExternalStorageState = Environment.getExternalStorageState();

		storagePaths = new HashMap<String,FsInfo>();

		getPathFromFstab();
		
		getPathFromEnvVal();
		
		checkMountedStorage();


	}


	/**
	 * vold.fstabt@C̗LԂ
	 * 
	 * @return@tureő݂
	 */
	public boolean isExistFstabFile() {
		
		return fstabExistStatus;
	}

	
	/**
	 * ftHgXg[W̃pXԂ
	 * 
	 * @return		EnvironmentNX擾łftHgXg[W̃pX
	 */
	public String getDefaultStoragePath() {

		return defaultExternalStorage.toString();
	}


	/**
	 * ftHgXg[W̏ԂԂ
	 * 
	 * @return		Environment.getExternalStorageState()̒lƓ
	 */
	public String getDefaultStorageStatus() {

		return defaultExternalStorageState;
	}


	/**
	 * OXg[W̌Ԃ
	 * 
	 * @return		Xg[W̌
	 */
	public int count() {

		return storagePaths.size();
	}

	
	/**
	 * OXg[W̌Ԃ
	 * 
	 * 擾ōȂXg[WOĊ肷
	 * OMIT_DEFAULT_STORAGEOMIT_UNMOUNT_STORAGEorZqłȂœw\B
	 * 
	 * @param condition		擾iGET_ALL_STORAGE@^@OMIT_DEFAULT_STORAGE@^@OMIT_UNMOUNT_STORAGEj
	 * 
	 * @return		Xg[W̌
	 */
	public int count(
			int condition
	){
		boolean dsf = ((condition & OMIT_DEFAULT_STORAGE) == 0);
		boolean usf = ((condition & OMIT_UNMOUNT_STORAGE) == 0);
		
		String dPath = getDefaultStoragePath();
		
		int cnt = 0;
		
		Iterator it = storagePaths.keySet().iterator();
		while (it.hasNext()) {
			String key = (String)it.next();
			FsInfo fsi = storagePaths.get( key );

			if ( key.equals(dPath) ){
				if (dsf) {
					if (fsi.isMounted) {
						cnt++;
					
					} else {
						if (usf) cnt++;
					}
				}
				continue;
			}

			if (fsi.isMounted) {
				cnt++;
			} else {
				if (usf) cnt++;
			}
		}

		return cnt;
	}
	
	
	/**
	 * Xg[W̃pXi}Eg|CgjꗗԂ
	 * 
	 * @return	}Eg|Cg̃pXꗗ
	 */
	public String[] getStoragePaths() {
		
		return getStoragePaths(GET_ALL_STORAGE);
	}

	/**
	 * Xg[W̃pXi}Eg|CgjꗗԂ
	 * 
	 * 擾ōȂXg[WOĈꗗ쐬
	 * OMIT_DEFAULT_STORAGEOMIT_UNMOUNT_STORAGEorZqłȂœw\B
	 * 
	 * @param condition		擾iGET_ALL_STORAGE@^@OMIT_DEFAULT_STORAGE@^@OMIT_UNMOUNT_STORAGEj
	 * 
	 * @return	}Eg|Cg̃pXꗗ
	 */
	public String[] getStoragePaths(
			int condition
	){
		boolean dsf = ((condition & OMIT_DEFAULT_STORAGE) == 0);
		boolean usf = ((condition & OMIT_UNMOUNT_STORAGE) == 0);

		ArrayList<String> tmp = new ArrayList<String>();

		String dPath = getDefaultStoragePath();

		Iterator it = storagePaths.keySet().iterator();

		while (it.hasNext()) {
			String path = (String)it.next();
			FsInfo fsi = storagePaths.get( path );

			if ( path.equals(dPath) ){
				if (dsf) {
					if (fsi.isMounted) {
						tmp.add(path);
					
					} else {
						if (usf) tmp.add(path);
					}
				}
				continue;
			}

			if (fsi.isMounted) {
				tmp.add(path);
			} else {
				if (usf) tmp.add(path);
			}
		}
		
		return tmp.toArray( new String[ tmp.size() ] );
	}
	
	
	/**
	 * t@CȂǂ̃tpXƃ}Eg|Cg̃pX̔r
	 * 
	 * @param fPath		Xg[W̃tH_t@C̃pX<br>TufBNgt@C܂łOK
	 * @param ePath		ϐ擾}Eg|Cg̃pX
	 * 
	 * @return			-1csv<br>0c擪}Eg|Cg̃pX܂ňv<br>1cSv
	 */
	private int comparePath(
			String fPath,
			String ePath
	){
		if (fPath.indexOf(ePath) != 0) return -1; // sv
		
		if (fPath.length() == ePath.length()) return 1;		// Sv
		
		ePath += "/";
		
		if (fPath.indexOf(ePath) != 0) return -1;
		
		if (fPath.length() == ePath.length()) return 1;		// Sv
		
		return 0;		// v
	}
	
	

	/**
	 * Xg[W̏Ԃ
	 * 
	 * @param	path	Xg[W̃tH_t@C̃pX<br>TufBNgt@C܂łOK
	 * @return			pXOXg[W̏i[FsInfoNX<br>nullŊOXg[Wł͂Ȃ
	 */
	public FsInfo getExStorageInfo(
			String path
	){
		ArrayList<String> tmp = new ArrayList<String>();

		Iterator it = storagePaths.keySet().iterator();

		while (it.hasNext()) {
			String sPath = (String)it.next();

			int res = comparePath( path,sPath );
			
			switch ( res ){
				case 1:
					tmp.clear();
				case 0:
					tmp.add( sPath );
					break;
			}
			
			if (res == 1) break;
		}

		int mlen = -1;
		String mPath = null;

		switch (tmp.size()){
		
			case 0:
				return null;		// vpXȂ  OXg[W̃pXł͂Ȃ

			case 1:
				return storagePaths.get(tmp.get(0)).clone(tmp.get(0));
		}

		for( int t=0; t<tmp.size(); t++){		// /mnt/sdcard/external_sd ƂႤ[J[ΉB

			int l = tmp.get(t).length();		// v̂̂AŒ̕ΏۂƂB

			if ( l > mlen ) {
				mlen = l;
				mPath = tmp.get(t);
			}
		}
		
		return storagePaths.get(mPath).clone(mPath);
	}

	/**
	 * ftHgXg[W̒Ƀ}Egꂽ̈悩ǂ𒲂ׂ
	 * 
	 * @param mountPoint	}Eg|Cg̃pX
	 * @param defPath		ftHgXg[W̃pX
	 * 
	 * @return				trueŒɃ}EgĂ
	 */
	private boolean isUnregisteredMountPoint(
			String mountPoint,
			String defPath
	){
		
		if (mountPoint.indexOf(defPath) != 0) return false;
		
		if (defPath.length() == mountPoint.length() ) return false;		// Sv͂Ȃ͂Ȃ񂾂

		String snd = mountPoint.substring( defPath.length()+1 );

		if (snd.indexOf("/") > 0) return false;		// Ώۂ̓ftHgXg[W̒
		
		if (snd.indexOf(".") == 0) return false;	// BȂ疳iȂtH_ɃXg[W}EgȂ낤jB
		
		return true;
	}
	
	
	/**
	 * FsInfoɃXg[W̏i[
	 * 
	 * @param fsi	FsInfõCX^XBnullŐVK쐬
	 * @param path	}Eg|Cg̃pX
	 * @param fsys	}EgĂt@CVXe
	 * 
	 * @return		Xg[W̏i}EgԁATCYAcʁji[FsInfo
	 */
	private FsInfo getFilledFsInfo(
			FsInfo fsi,
			String path,
			String fsys
	){
		StatFs sfs = new StatFs(path);
		
		if (fsi == null) fsi = new FsInfo();
		
		fsi.setMountStatus(true);
		fsi.setSize( sfs.getBlockSize(), sfs.getBlockCount(), sfs.getAvailableBlocks() );
		fsi.setFileSystem( fsys );
		return fsi;
	}


	/**
	 * }Egς݂̃Xg[W𒲂ׂ
	 */
	private void checkMountedStorage() {
		
		BufferedReader reader = null;

		String defPath = defaultExternalStorage.toString();

		try{
			reader = new BufferedReader( new FileReader("/proc/mounts") );

			String line;

			while ((line = reader.readLine()) != null) {
				String[] ele = line.split( "\\s+" );
				
				if ( storagePaths.containsKey( ele[1] ) ) {

					FsInfo fsi = (FsInfo)storagePaths.get( ele[1] );
					storagePaths.put( ele[1], getFilledFsInfo( fsi, ele[1], ele[2]) );

				} else {							// ϐɂȂāA
					if (searchUnregisteredMountPointFlag) {		// w肳ĂꍇŁA
						if (isUnregisteredMountPoint( ele[1], defPath ) ){	// ftHgXg[W̉Ƀ}Egꂽ̈悪  ԂSDJ[h낤iISW13HTΉj

							storagePaths.put( ele[1], getFilledFsInfo( null, ele[1], ele[2] ) );
						}
					}
				}
				
			}

		}
		catch(FileNotFoundException e) {
			throw new RuntimeException(e);
		}
		catch(IOException e) {
			throw new RuntimeException(e);
		}
		finally {
			if(reader != null) {
				try {
					reader.close();
				}
				catch (IOException e) {}
		    }
		}
	}

	
	/**
	 * Xg[Ww肵ĂƂڂpXϐo
	 */
	private void getPathFromEnvVal() {

		Map<String, String> envs = System.getenv();
		
		Iterator it = envs.keySet().iterator();

		while (it.hasNext()) {
			String key = (String)it.next();

			for(int t=0; t<EnvValKeywords.length; t+=2){

				if ( key.matches(EnvValKeywords[t]) ) {
					
					if (EnvValKeywords[t+1] != null) {	// f~^w肳Ăꍇ͐؂蕪

						String[] ele = envs.get(key).split( EnvValKeywords[t+1] );

						for(String mp: ele){
							if (mp.length() > 0) {
								if (storagePaths.containsKey(mp) == false) storagePaths.put( mp, new FsInfo() );
							}
						}

					} else {

						String mp = envs.get(key);

						if (mp.length() >0) {
							if (storagePaths.containsKey(mp) == false)  storagePaths.put( mp, new FsInfo() );
						}

					}
					
					break;
				}
			}
		}
		
		String dsPath = defaultExternalStorage.toString();
		if ( storagePaths.containsKey( dsPath ) == false ) {		// ftHgXg[WꗗɊ܂܂Ȃꍇ

			storagePaths.put( dsPath, new FsInfo() );
		}
	}
	
	
	/**
	 * vold.fstabt@C}EgĂp[eBV̏擾
	 */
	public void getPathFromFstab() {
		
		try{
			BufferedReader bfr = new BufferedReader( new FileReader( pathOfFstab ) );
			
			String line;
			
			Pattern patt = Pattern.compile( fstabMatchingPatt );
			
			while( (line = bfr.readLine()) != null ){
			
				
				Matcher mchr = patt.matcher( line );
				
				if ( mchr.find() ) storagePaths.put( mchr.group(3), new FsInfo( mchr.group(2) ) );
			}

			bfr.close();
			bfr = null;
			
			fstabExistStatus = true;
		}
		
		catch(FileNotFoundException e) {	// t@CΌÂOSȂ̂Ŗ

			fstabExistStatus = false;
		}
		catch(IOException e) {
			
			fstabExistStatus = false;	// VXẽ݂G[oꍇ݂ȂƂɂ
		}
	}
	
	
	
}	
	


