package jp.ne.sakura.zautale.StoraDetector;

import android.app.Activity;
import android.os.Bundle;
import android.os.Build;
import android.os.Environment;

import android.view.View;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.AdapterView;

import android.app.AlertDialog;
import android.content.DialogInterface;

import java.util.ArrayList;
import java.util.Map;
import java.util.Set;
import java.util.Iterator;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
	
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.FileReader;

import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.entity.StringEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.util.EntityUtils;



import android.util.Log;


public class Start extends Activity {

	/** O\TextView */
	private TextView LogcatTextView;

	/** O\IXsi[ */
	private Spinner TextChangeSpinner;
	
	private ScrollView LogBaseScrollView;
	
	/** Of[^̋L^obt@ */
	private StringBuffer logCommon;		// ʕ̃O
	private StringBuffer logNormal;		// ʏ팟õO
	private StringBuffer logForce;		// õO

	/** O{̂i[t@C̖OȋOuj */
	private String FileName;

	/** @햼 */
	private String Device;

	/** o[W */
	private String Version;
	
	/** |[gMCGIURL */
	private static final String cgiUrl = "http://zautale.sakura.ne.jp/android/ExternalStorageChecker/rsvReport.cgi";

	/** o[h */
	private boolean currentMode = false;
	
	/** dMh~tO */
	private static boolean sendFlag = false;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.main);

		LogcatTextView = (TextView)this.findViewById( R.id.txvi_logcat );
		TextChangeSpinner = (Spinner)this.findViewById(R.id.spnr_change_text);
		LogBaseScrollView = (ScrollView)this.findViewById(R.id.scrv_logbase );

		TextChangeSpinner.setOnItemSelectedListener(
				new OnItemSelectedListener(){
					public void onItemSelected(
							AdapterView parent,
							View v,
							int pos,
							long id
					){
						LogBaseScrollView.scrollTo(0, 0);

						dispLogText( (pos != 0) );						
					}

					public void onNothingSelected(AdapterView parent){

					}
				}
		);
		
		logForce = new StringBuffer();
		logNormal = new StringBuffer();
		
		scanCommonPart();
		Scanning( true );
		Scanning( false );
	}
	
	
	/**
	 * Wf[^\
	 * 
	 * @param 
	 */
	private void dispLogText(
			boolean mode
	){
		StringBuffer tmp = new StringBuffer("---[Scan Mode]------\n\n");
		
		if (mode) {
			
			tmp.append("Force\n\n");

			tmp.append(logCommon);
			tmp.append("\n\n");
			
			tmp.append(logForce);
			tmp.append("\n\n");

		} else {
			
			tmp.append("Normal\n\n");

			tmp.append(logCommon);
			tmp.append("\n\n");
			
			tmp.append(logNormal);
			tmp.append("\n\n");
		}
		
		LogcatTextView.setText( tmp.toString() );
	}
	
	
	
	
	/**
	 * o
	 * 
	 */
	private void Scanning(
			boolean mode
	){
		StringBuffer logText;
		
		if (mode)
			logText = logForce;
		else 
			logText = logNormal;
		
		ExternalStorageChecker esc = new ExternalStorageChecker( mode );

		catDefaultStorageInfo( logText, esc );
		catPathListToLog( logText, esc );
		catStorageInfoToLog( logText, esc );
	}
	
	
	private void scanCommonPart() {
		
		logCommon = new StringBuffer();
		
		catDeviceInfo();
		catEnvParamToLog();
		catFstab();
		catResOfMountComm();
	}
	
	
	
	/**
	 * OM̊mF_CAO\
	 * 
	 * @param v		{^View
	 */
	public void onClickReportButton(
			View v
	){
		if (sendFlag) {

			Toast.makeText(this,"Mς݂łB\n͂肪Ƃ܂B",Toast.LENGTH_SHORT).show();
			return;
		}
		
		AlertDialog.Builder adb = new AlertDialog.Builder(this);

		adb.setMessage("\Ă𑗐M܂B\n낵łH");

		adb.setPositiveButton(
				"Yes",
				new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {

						submitLog();
						sendFlag = true;
					}
				}
		);
		
		adb.setNegativeButton(
				"No",
				new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {

					}
				}
		);
		
		adb.setCancelable(true);
		adb.create().show();
		
	}
	

	/**
	 * O𑗐M
	 */
	public void submitLog() {
		
		StringBuffer param = new StringBuffer("Device=");
		
		param.append( Device );

		param.append( "&Version=" );
		param.append( Version );
		
		param.append( "&FileName=" );
		param.append( FileName );
		
		param.append( "&StorageInfo=" );

		param.append( "<Normal Scan log>\n" );
		param.append( logNormal );
		
		param.append( "\n\n\n<Force Scan log>\n" );
		param.append( logForce );

		param.append( "\n\n\n<Common log>\n" );
		param.append( logCommon );
		param.append( "---{EOF}-------------" );

		try{
			HttpPost method = new HttpPost( cgiUrl );
			DefaultHttpClient client = new DefaultHttpClient();
			
			StringEntity paramEntity = new StringEntity( param.toString() );
			paramEntity.setChunked( false );
			paramEntity.setContentType( "application/x-www-form-urlencoded" );
			method.setEntity( paramEntity );

			HttpResponse response = client.execute( method );
			
			int status = response.getStatusLine().getStatusCode();
			if ( status != HttpStatus.SC_OK ) throw new Exception( "" );
			
			String res = EntityUtils.toString( response.getEntity(), "UTF-8" );
			
			Toast.makeText(this,"M܂",Toast.LENGTH_SHORT).show();
		}
		catch( Exception e ){
			
			Toast.makeText(this,"ʐMɎs܂",Toast.LENGTH_SHORT).show();
		}
		
		
	}
	
	
	/**
	 * [o
	 */
	private void catDeviceInfo() {
		
		logCommon.append( "---[Device info]------\n\n" );
		
		logCommon.append( Build.MODEL );
		logCommon.append( "  ( " );
		logCommon.append( Build.VERSION.RELEASE );
		logCommon.append( " )" );
		
		logCommon.append( "\n" );
		
		logCommon.append( Build.MANUFACTURER );
		logCommon.append( "\n" );
		
		logCommon.append( Build.BRAND );
		logCommon.append( "\n\n" );

		Device = Build.MODEL;					// |[gMp̏ʂɗpӂ
		Version = Build.VERSION.RELEASE;
		FileName = Pattern.compile("\\s+").matcher(Device + "_" + Version).replaceAll("_");
	}
	
	
	/**
	 * ftHg̊OXg[W̏o
	 * 
	 * @param esc	ExternalStorageCheckerIuWFNg
	 */
	private void catDefaultStorageInfo(
			StringBuffer logText,
			ExternalStorageChecker esc
	) {
		logText.append( "---[Default storage info]------\n\n" );

		logText.append( esc.getDefaultStoragePath() );
		logText.append( "\n   -> " );
		logText.append( esc.getDefaultStorageStatus() );
		logText.append( "\n\n" );
	}
	
	
	/**
	 * _~[̃tpX𐶐ăXg[W̏o
	 * 
	 * @param esc	ExternalStorageCheckerIuWFNg
	 */
	private void catStorageInfoToLog(
			StringBuffer logText,
			ExternalStorageChecker esc
	) {
		String[] pList = esc.getStoragePaths();

		ArrayList<String> paths = new ArrayList<String>();
		
		
		for(int t=0; t<pList.length; t++){		// ̂܂
			paths.add(pList[t]);
		}
		
		for(int t=0; t<pList.length; t++){		// ̃t@C
			paths.add(pList[t]+"/test");
		}
		
		for(int t=0; t<pList.length; t++){		// Ovt@C
			paths.add(pList[t]+"_test");
		}

//		paths.add("/data/test");	// Xg[Wł͂Ȃ
		
		logText.append( "---[Dummy path test]------\n\n" );

		for(int t=0; t<paths.size(); t++){

			String path = paths.get(t);
			
			logText.append( path );
			logText.append( "\n   -> " );
			
			ExternalStorageChecker.FsInfo fsi = esc.getExStorageInfo(path);
			if (fsi == null){
				logText.append( "Unmountable" );
			} else {
				
				logText.append( fsi.mountPoint );
				logText.append( " , " );
				logText.append( (fsi.labelForVolume==null)?"(no label)":fsi.labelForVolume );
				logText.append( " , " );
				logText.append( fsi.fileSystem );
				logText.append( "\n   -> " );
				logText.append( fsi.isMounted );
				logText.append( " , " );
				logText.append( fsi.totalSzie );
				logText.append( " , " );
				logText.append( fsi.availableSize );
			}

			logText.append( "\n\n" );
		}

	}


	/**
	 * pXꗗo
	 * 
	 * @param esc	ExternalStorageCheckerIuWFNg
	 */
	private void catPathListToLog(
			StringBuffer logText,
			ExternalStorageChecker esc
	) {
		int[] conds = {
				ExternalStorageChecker.GET_ALL_STORAGE,
				ExternalStorageChecker.OMIT_DEFAULT_STORAGE,
				ExternalStorageChecker.OMIT_UNMOUNT_STORAGE,
				ExternalStorageChecker.OMIT_DEFAULT_STORAGE|ExternalStorageChecker.OMIT_UNMOUNT_STORAGE
		};
		
		String[] sti = {
				"GET_ALL_STORAGE",
				"OMIT_DEFAULT_STORAGE",
				"OMIT_UNMOUNT_STORAGE",
				"OMIT_DEFAULT_STORAGE + OMIT_UNMOUNT_STORAGE"
		};
		
		
		
		logText.append( "---[Mount point list]------\n\n" );
		
		for(int t=0; t<conds.length; t++){
			logText.append( sti[t] );
			logText.append( "\n" );
			
			logText.append( "\tCount:" );
			logText.append( esc.count( conds[t] ) );
			logText.append( "\n" );
			
			String[] pList = esc.getStoragePaths( conds[t] );

			for(String p:pList){
				
				logText.append( "\t\t" );
				logText.append( p );
				logText.append( "\n" );
			}
			logText.append( "\n" );
		}
		
	}


	/**
	 * ϐo
	 */
	private void catEnvParamToLog() {
		
		Map<String, String> envs = System.getenv();
		
		Iterator it = envs.keySet().iterator();
		
		logCommon.append( "---[Environmental variables]------\n\n" );

		while (it.hasNext()) {

			String key = (String)it.next();

			logCommon.append( key );
			logCommon.append( "=" );
			logCommon.append( envs.get(key) );
			logCommon.append( "\n" );
		}

		logCommon.append( "\n" );
	}


	/**
	 * }EgR}ȟʂo
	 */
	private void catResOfMountComm() {
		
		logCommon.append( "---[Result of mount command]------\n\n" );

		
		BufferedReader reader = null;

		try{
			Process process = Runtime.getRuntime().exec("mount");
			reader = new BufferedReader(new InputStreamReader(process.getInputStream()));

			String line;

			while ((line = reader.readLine()) != null) {

				logCommon.append( line );
				logCommon.append( "\n" );
			}

			process.waitFor();

			logCommon.append( "\n" );
		}
		catch(IOException e) {
			throw new RuntimeException(e);
		}
		catch (InterruptedException e) {
		    throw new RuntimeException(e);
		}
		finally {
			if(reader != null) {
				try {
					reader.close();
				}
				catch (IOException e) {}
		    }
		}

	}

	/**
	 * /system/etc/vold.fstab ̓eǂݏo
	 */
	private void catFstab() {
		
		logCommon.append( "---[Content of fstab file]------\n\n" );

		try{
			BufferedReader bfr = new BufferedReader( new FileReader("/system/etc/vold.fstab" ) );
			
			String line;

			while( (line = bfr.readLine()) != null ){
			
				logCommon.append( line );
				logCommon.append( "\n" );
			}

			logCommon.append( "\n" );
			
			bfr.close();
			bfr = null;
		}
		
		catch(FileNotFoundException e) {
			
			logCommon.append( "File not found. ( /system/etc/vold.fstab )\n\n" );
			
		}
		catch(IOException e) {

			logCommon.append( "I/O error\n\n" );
			
		}
		
		
		
	}

}